
/////////////////////////////////////////////////////////////////////
// VOODB2 (Virtual Object Oriented Database 2)
// Generic performance evaluation model of OODBs
// Version 2.0 C++, April 1998
// Jerome Darmont
// LIMOS, Universite Blaise Pascal (Clermont-Ferrand II), France
/////////////////////////////////////////////////////////////////////
// voodb2uc.h: Utilitary classes definition
/////////////////////////////////////////////////////////////////////

class ChList;
class IntCell;

/////////////////////////////////////////////////////////////////////
// CLASS ChList
/////////////////////////////////////////////////////////////////////
// Chained list of integers
/////////////////////////////////////////////////////////////////////

class ChList {

  public:                       // Methods

    ChList();                   // Constructor
    ~ChList();                  // Destructor
    void Insert(int place, int value); // Insertion 
    void Delete(int place);     // Deletion
    void Update(int place, int value); // Update
    void Reverse();             // List reversal
    int Scan(int place);        // Return value
    int NbElem();               // Retour number of elements
    void Display();             // Display list
    void Print();               // Display pointers

  private:                      // Attributes

    int nbelem;                 // Number of elements
    IntCell *head;              // Ptr. toward list head
    IntCell *queue;             // Ptr. toward list end

    int position;               // Current position within the list
    IntCell *cur;               // Current cell pointer
    IntCell *prev;              // Previous cell pointer
    IntCell *next;              // Next cell pointer

    // Private method: positioning in a list at a given slot
    //                 with update of attributes position,
    //                 cur, prev, and next

    void Pos(int place);

};

/////////////////////////////////////////////////////////////////////
// CLASS IntCell
/////////////////////////////////////////////////////////////////////
// Integer chained list cell
/////////////////////////////////////////////////////////////////////

class IntCell {

  public:                       // Methods

    IntCell(int val);           // Constructor
    void SetVal(int val);       // Value initialization 
    void SetNext(IntCell *n);   // Next ptr. initialization 
    void SetPrev(IntCell *n);   // Prev ptr. initialization 
    int Value();                // Return value
    IntCell *Next();            // Return next cell
    IntCell *Prev();            // Return previous cell
    
  private:                      // Attributes

    int value;                  // Int value
    IntCell *next;              // Next cell (ptr)
    IntCell *prev;              // Previous cell (ptr)

};

